#include "node.h"
#include "string.h"

void Add(PNode &Head, char *word)
{
	PNode NewNode=(PNode)malloc(sizeof(node)), temp;
	NewNode->next=NULL;
	NewNode->prev=NULL;
	strcpy(NewNode->word,word);

	if(!Head)
	{
		Head=NewNode;
		return;
	}
	temp=Head;
	while(temp->next)
		temp=temp->next;
	NewNode->prev=temp;
	temp->next=NewNode;
	return;
}
void ShowNode(PNode Head)
{
	PNode temp;
	temp=Head;
	if(!Head)
	{
		printf("\n :  !\n\n");
		return;
	}
	while(temp)
	{
		printf("%s ",temp->word);
		temp=temp->next;
	}
	return;
}
void DivideByWord(char *sent, PNode &Head)
{
	char temp[N];
	int i=0, ib, ie, j, g;
	while (sent[i]!='\0')
	{
		while(sent[i]==' ') //    
			i++;
		ib=i; //    
		while((sent[i]!=' ') && (sent[i]!='\0')) //    
			i++;

		for(j=ib, g=0; j<i; j++, g++)
		{
			temp[g]=sent[j];
		}
		temp[g++]='\0';
		Add(Head,temp);
		while(sent[i]==' ')
			i++;
	}
}
void DelNode(PNode &Head, PNode OldNode)
{
	if(!Head)
	{
		printf("\n !\n");
		return;
	}
	if(OldNode==Head)
	{
		Head=OldNode->next;
		return;
	}
	OldNode->prev->next=OldNode->next;
	OldNode->next->prev=OldNode->prev;
	free(OldNode);
}
void DelNotRevelant(PNode &Head, char *pattern)
{
	int cht = 0;
	PNode temp=Head, temp1;

	while(temp->next)
	{
		cht = Comparison(pattern,temp->word);
		if(cht == 0)
		{
			temp1=temp->next;
			DelNode(Head,temp);
			temp=temp1;
		}
		else
			temp=temp->next;

	}
	if(cht != 0)
	{
		for(temp1=Head; temp1->next!=temp; temp1=temp1->next);
		temp1->next=NULL;
		free(temp);
	}
}
int Comparison(char *pattern, char *word)
{
	int i, l=0, err=0;
	l=strlen(pattern);
	for(i=0; i<= l; i++)
	{
		if(pattern[i]!=word[i])
		{
			err=1;
			break;
		}
	}
	return err;
}
