#ifndef NODE_H
#define NODE_H
#include <stdio.h>
#include <stdlib.h>
#include <locale.h>
#include <string.h>
#define N 128

typedef
struct node
{
	char word[N];
	node *next, *prev;
} *PNode;

void Add(PNode &Head, char *word);
void ShowNode(PNode Head);
void DelNode(PNode &Head, PNode OldNode);
void DivideByWord(char *sent, PNode &Head);
void DelNotRevelant(PNode &Head, char *pattern);
int Comparison(char *pattern, char *word);

#endif